/**********************************************************************/
/* COPYRIGHT IBM CORP. 2011, 2013                                     */
/**********************************************************************/
SUBR1    CSECT
SUBR1    AMODE 31
SUBR1    RMODE ANY
         SAVE  (14,12),,*          SAVE CALLER'S REGISTERS IN CALLER-
*                                  PROVIDED R13 SAVE AREA
*
         LR    r3,r0               Save usable ENVblock
         USING ENVBLOCK,r3
         LR    r4,r1               Save EFPL
         USING EFPL,r4
*
         LR    r12,r15             SET UP PROGRAM BASE REGISTER
         USING SUBR1,r12
*
         LA    r2,72+MYAREASZ      Space for savearea + my autodata
*
         GETMAIN RU,LV=(r2)        GET MY REENTRANT SAVEAREA+
         ST    r13,4(,r1)          SAVE CALLER'S SAVEAREA ADDRESS IN MY
*                                  SAVEAREA (BACKWARD CHAIN)
         ST    r1,8(,r13)          SAVE MY SAVEAREA ADDRESS IN CALLER'S
*                                  SAVEAREA (FORWARD CHAIN)
         LR    r13,r1              PUT MY SAVEAREA ADDRESS IN R13
*   END OF ENTRY CODE, BEGIN PROGRAM CODE HERE
**
         LA    r11,72(r13)         make autodata addressable
         USING MYAREA,r11
         ST    r2,mysize           remember total size for later...
*
         WTO   'SUBR1 before',ROUTCDE=11
*
         L     r5,EFPLEVAL         pointer to address of...
         L     r5,0(r5)            .. evalblock
         USING EVALBLOCK,r5
*
         L     r6,ENVBLOCK_PARMBLOCK
         USING PARMBLOCK,r6
         L     r6,PARMBLOCK_SUBCOMTB
         USING SUBCOMTB_HEADER,r6
*
         MVC   EVALBLOCK_EVLEN,=F'24'
         MVC   EVALBLOCK_EVDATA(4),EVALBLOCK_EVSIZE
         MVC   EVALBLOCK_EVDATA+4(20),SUBCOMTB_HEADER
*
         WTO   'SUBR1 after',ROUTCDE=11
*
RET      LHI   r15,0
         ST    r15,myret
         J     XIT
RET2     LHI   r15,-1              return w/ -1
         ST    r15,myret
         J     XIT
**
*   BEGIN EXIT CODE
XIT      LR    r1,r13              COPY MY SAVEAREA ADDRESS
         L     r2,mysize
         L     r3,myret
         L     r13,4(,r13)         RESTORE CALLER'S SAVEAREA ADDRESS
         FREEMAIN RU,A=(1),LV=(r2) FREE MY REENTRANT SAVEAREA+
         LR    r15,r3              SET RETURN CODE
         L     r14,12(,r13)        RESTORE CALLER'S R14
         LM    r2,r12,28(r13)      RESTORE CALLER'S R2-R12
         BR    r14                 RETURN TO CALLER
**
         YREGS
**
envb0    IRXENVB 
efpl1    IRXEFPL 
evalb    IRXEVALB
parmb    IRXPARMB
subcomt  IRXSUBCT
**
MYAREA   DSECT
*
myret    DS   F
mysize   DS   F
**
* 
MYAREASZ EQU  *-MYAREA 
         END 
