/**********************************************************************/
/* COPYRIGHT IBM CORP. 2012, 2013                                     */
/**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>

#include <irxevalb.h>
#include <irxargtb.h>
#include <irxinstb.h>     

typedef struct irxexec_flags_s {
  unsigned int 
    command : 1, 
    function : 1,
    subroutine : 1 ,
    extended_retcodes : 1 ,
    _reserved : 4;
  char _reseved_flags[3];
} IRXEXEC_FLAGS;

typedef int (IRXEXEC)(void** execblk, void** argtable, IRXEXEC_FLAGS flags, 
                      void** instor, void** cppl, void** evalb,
                      void** work, void** user,
                      void** envb, void* retcd );
#pragma linkage(IRXEXEC, OS)

int aa = 0;
void *envbp0=0, *null=NULL, *userfld1=0;

IRXEXEC_FLAGS execflags = {0, 0, 1, 1, 0};

main (int argc, char **argv)
{


 #define EVDATA_SIZE 240
 struct eval1 {
  struct evalblock EVB1;
  char restofevdata[EVDATA_SIZE];
 } EVAL1 = { 0, ((EVDATA_SIZE/8)+2), 0};  /* how do they get 250, has to be 240 or 248 ? */
 unsigned char *EVAL1data_ptr = &EVAL1.EVB1.evalblock_evdata;

 #define ARG1 "hello"
 #define ARG2 " REXX "
 #define ARG3 "from LE"
 #define ARGEND "\xff\xff\xff\xff\xff\xff\xff\xff"

 struct argtable1 {
   struct argtable_entry args1[3];
   struct argstring args1end;
 } ARGTABLE1 = 
 {ARG1, sizeof(ARG1)-1,
  ARG2, sizeof(ARG2)-1,
  ARG3, sizeof(ARG3)-1,
  ARGEND};

 char *REXX1[] = {
   "Say; Say COPIES('=',72)"
  ,"Parse Arg arg1, arg2, arg3"
  ,"Say \"Args to REXX are:\" arg1\",\" arg2\",\" arg3\".\""
  ,"Parse Source src"
  ,"Say \"REXX source is '\"src\"'\""
  ,"Say COPIES('=',72); Say"
  ,"Exit 72"
 };

 #define REXXIN1_CNT (sizeof(REXX1)/sizeof(char*))
 struct instblk_entry REXXIN1[REXXIN1_CNT];

 struct instblk_header INSTBLK1 = 
 {"IRXINSTB",
  sizeof(INSTBLK1),
  0,
  0, /* address of INSTOR exec */
  sizeof(struct instblk_entry)*REXXIN1_CNT,
  "inSideMe",
  "-ddNone-",
  "SH      ",
  0,
  8,
  "NoDSname",
  0};


 IRXEXEC* execfunc;

 int retcode, RC, rr;

 struct argtable1      *ARGTABLE1_ptr = &ARGTABLE1;
 struct eval1          *EVAL1_ptr     = &EVAL1;
 struct instblk_header *INSTBLK1_ptr  = &INSTBLK1;

 INSTBLK1._instblk_address = &REXXIN1[0];

 for (rr=0; rr<REXXIN1_CNT; rr++) {
   REXXIN1[rr].instblk_stmt_ = REXX1[rr];
   REXXIN1[rr].instblk_stmtlen = strlen(REXX1[rr]);
 }

 execfunc = (IRXEXEC*) fetch("IRXEXEC");
 if (execfunc==NULL) { perror("fetch IRXEXEC failed:"); exit(1); }

 fprintf (stderr, "C main beginning %d args:\n",argc);
 for (aa=0; aa<argc; aa++) {
   printf("arg[%03d]=<%s>\n", aa, argv[aa]);
 }

 ARGTABLE1.args1[0].argtable_argstring_ptr = argv[1];
 ARGTABLE1.args1[0].argtable_argstring_length = strlen(argv[1]);

 RC=execfunc(&null,
             (void**) &ARGTABLE1_ptr,
             execflags,
             (void**)&INSTBLK1_ptr,
             &null,
             (void**)&EVAL1_ptr,
             &null,
             &userfld1,
             &envbp0,
             &retcode);

 printf("retcode is: %d\n", retcode);
 printf("EVAL_data is: %.8s\n", EVAL1data_ptr);

 if (RC==0) RC=strtoul((char *)EVAL1data_ptr,NULL,0);

 exit(RC);

}

