/* REXX */
/**********************************************************************/
/* COPYRIGHT IBM CORP. 2011, 2013                                     */
/**********************************************************************/

Numeric Digits 10 /* needed for STinitD (an address) */

ans = SUBR1()
Say 'EVdata size returned='LENGTH(ans) 

evsize = SUBSTR(ans,1,4); Say 'EVsize (length available without calling IRXRLT(GETBLOCK))='C2D(evsize)*8-16

SThdr=SUBSTR(ans,5,20) /* SUBCOMTB */
STadrD = C2D(SUBSTR(SThdr,1,4))
STtotD = C2D(SUBSTR(SThdr,5,4))
STusedD= C2D(SUBSTR(SThdr,9,4))
STelenD= C2D(SUBSTR(SThdr,13,4))
STinitD= C2D(SUBSTR(SThdr,17,4))

Say 'SUBCOM Table:'
Say ' total entries:' STtotD
Say ' used  entries:' STusedD
Say ' initial environment:' STORAGE(D2X(STinitD),8)
Say ' all environments (token length='STelenD-16'):'
Do ss=1 To STusedD
  STentry = STORAGE(D2X(STadrD),STelenD)
  Say '  'RIGHT(ss,5)' name='SUBSTR(STentry,1,8) 'routine='SUBSTR(STentry,9,8) 'token='SUBSTR(STentry,17)'.'
  STadrD = STadrD + STelenD
End ss

Exit 0
